<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\AnaliseCotacoes\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Sup00600HistoricoComparativoCotacoesController extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;
    

    public function __construct($reportService, $entityManager, $qr2Strategy,$dataSourceManager,$newCode, $environment, $connection) {

        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;
        $this->dataSourceManager   = $dataSourceManager;
        $this->newCode             = $newCode;
        $this->environment         = $environment;
        $this->connection          = $connection;
    }
    

    protected $reportMapping = array ();
     public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {   
        $row = $request->getRow();
        $row['__report_name'] = str_replace(".QR2","", $row['REPORT_NAME']);
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $row['CDFILIAL1'] = $row['CDFILIAL'];
        $row['CDFILIAL2'] = $row['CDFILIAL'];
        $row['CDFILIAL3'] = $row['CDFILIAL'];
        $this->reportMapping[$this->stNomeRel] =
            array (
            'strategy' => $row['STRATEGY'],
            'parameterMapping' =>
            array (
                "REGIAO"            => "L_CDREGIAO",
                "FILIAL"            => "L_CDFILIAL",
                "CDFILIALCENTCMP1"  => "L_CDFILCENTCMP",
                "CDFILIAL"          => "P_CDFILIAL",
                "FORNECEDOR"        => "L_CDFORNECED",
                "CDFORNECED1"       => "L_CDFORNECED1",
                "CDPRODINI"         => "P_CDINI",
                "CDPRODFIM"         => "P_CDFIN",
                "CDPRODINI1"        => "P_CDPRODINI",
                "CDPRODFIM1"        => "P_CDPRODFIN",
                "DTINI"             => "P_DTINI", 
                "DTFIN"             => "P_DTFIN",
                "DTINI1"            => "P_DTINICIAL",
                "DTFIN1"            => "P_DTFINAL"
            ),
        );
        
    }
   
}



   
  
        


