<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\Pedido\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Teknisa\SUP\Util\SupUtilities;

class Sup09400 extends \Zeedhi\Framework\Controller\Report
{
    protected $birtStrategy;
    protected $environment;
    protected $reportService;
    protected $QR2Strategy;
    protected $supUtilities;
    
    public function __construct($reportService, $birtStrategy, $environment, $QR2Strategy, $supUtilities) {
        $this->reportService     = $reportService;
        $this->birtStrategy      = $birtStrategy;
        $this->environment       = $environment;
        $this->QR2Strategy       = $QR2Strategy;
        $this->supUtilities       = $supUtilities;
    }
    
    /** @var array */
    protected $reportMapping = array (
        'SUP09400' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFORNECED"     => "P_CDFORNECED",
                        "CDFILIAL"       => "P_CDFILIAL",
                        "NRPEDIDOCOL"    => "P_NRPEDIDOCOL",
                        "NRORG"          => "P_NRORG"
                    )
            ),
            'SUP09402' =>
            array (
                'strategy' => 'QR2',
                'parameterMapping' =>
                    array (
                        "CDFORNECED"     => "P_CDFORNECED",
                        "CDFILIAL"       => "P_CDFILIAL",
                        "NRPEDIDOCOL"    => "P_NRPEDIDOCOL"
                    )
            ),
            'SUP09410' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        "CDFORNECED"     => "P_CDFORNECED",
                        "CDFILIAL"       => "P_CDFILIAL",
                        "NRPEDIDOCOL"    => "P_NRPEDIDOCOL",
                        "NRORG"          => "P_NRORG"
                    )
            )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        if ($row['__report_name'] == 'SUP09400') {
            $idSisDos = $this->supUtilities->getIdSisDos();
            $row['__report_name'] = $idSisDos == 3 ? 'SUP09410' : 'SUP09400';
        }
        
        $row['NRORG'] = $this->environment->getNrorgTrab();
        $qr2type = isset($row['QR2TYPE']) ? $row['QR2TYPE'] : 'PDF';

        $this->birtStrategy->setReportFormat($qr2type);
        $this->QR2Strategy->setQr2Type($qr2type);
    }

}